#
# Structure for table "kt_chartexample"
#

CREATE TABLE IF NOT EXISTS `kt_chartexample` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `start` int(6) unsigned NOT NULL DEFAULT '0',
  `total` int(6) unsigned NOT NULL DEFAULT '0',
  `monitor` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

#
# Structure for table "kt_device_devlist"
#

CREATE TABLE IF NOT EXISTS `kt_device_devlist` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` char(30) NOT NULL DEFAULT '',
  `label` varchar(100) DEFAULT NULL,
  `group` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `type` enum('thinclient','station','pc','vxstation') NOT NULL DEFAULT 'thinclient',
  `status` enum('normal','discard','wrong','unknown') NOT NULL DEFAULT 'normal',
  `dept` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `charge` char(30) NOT NULL DEFAULT '',
  `user` char(30) NOT NULL DEFAULT '',
  `version` char(50) NOT NULL DEFAULT '',
  `join` date NOT NULL DEFAULT '0000-00-00',
  `description` text NOT NULL,
  `deleted` tinyint(3) NOT NULL DEFAULT '0',
  `tcpip` char(50) NOT NULL DEFAULT '',
  `cpuID` char(50) NOT NULL DEFAULT '',
  `deviceSN` char(50) NOT NULL DEFAULT '',
  `monitorSN` varchar(50) NOT NULL DEFAULT '',
  `monitorVersion` varchar(50) NOT NULL DEFAULT '',
  `assetNumber` varchar(50) NOT NULL DEFAULT '',
  `vidioCard` varchar(50) NOT NULL DEFAULT '',
  `discCapacity` varchar(50) NOT NULL DEFAULT '',
  `memoryCapacity` varchar(50) NOT NULL DEFAULT '',
  `system` varchar(50) NOT NULL DEFAULT '',
  `mac` varchar(50) NOT NULL DEFAULT '',
  `purpose` varchar(100) NOT NULL DEFAULT '',
  `displayName` varchar(50) NOT NULL DEFAULT '',
  `dieDate` date NOT NULL DEFAULT '0000-00-00',
  `manageip` char(50) NOT NULL DEFAULT '',
  `count` int(11) NOT NULL DEFAULT '1',
  `loginaddr` varchar(255) NOT NULL DEFAULT '',
  `repairstart` date NOT NULL DEFAULT '0000-00-00',
  `repairend` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`id`),
  KEY `dept` (`dept`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

#
# Structure for table "kt_device_group"
#

CREATE TABLE IF NOT EXISTS `kt_device_group` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `name` char(30) NOT NULL,
  `type` enum('station','laptop','server','other','discard') NOT NULL DEFAULT 'station',
  `desc` char(255) NOT NULL DEFAULT '',
  `createdate` date NOT NULL DEFAULT '0000-00-00',
  `deleted` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

#
# Structure for table "kt_kendoui"
#

CREATE TABLE IF NOT EXISTS `kt_kendoui` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` char(20) DEFAULT NULL,
  `computer` char(50) DEFAULT NULL,
  `activetime` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

#
# Structure for table "kt_svnmanager_authz"
#

CREATE TABLE IF NOT EXISTS `kt_svnmanager_authz` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `rep` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `folder` char(255) NOT NULL DEFAULT '/',
  `user` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `authz` enum('','r','w','rw') NOT NULL DEFAULT 'r',
  PRIMARY KEY (`id`),
  UNIQUE KEY `rep+folder+user` (`rep`,`folder`,`user`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

#
# Structure for table "kt_svnmanager_repositories"
#

CREATE TABLE IF NOT EXISTS `kt_svnmanager_repositories` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `name` char(50) NOT NULL DEFAULT '',
  `title` varchar(50) NOT NULL DEFAULT '',
  `project` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `dept` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `charger` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `class` char(10) NOT NULL DEFAULT '',
  `disable` enum('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

#
# Structure for table "kt_svnmanager_user"
#

CREATE TABLE IF NOT EXISTS `kt_svnmanager_user` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `dept` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `account` char(30) NOT NULL DEFAULT '',
  `svnaccount` char(30) NOT NULL DEFAULT '',
  `windowsID` char(50) NOT NULL DEFAULT '',
  `desc` text NOT NULL,
  `disable` enum('0','1') NOT NULL DEFAULT '0',
  `type` enum('normal','admin') NOT NULL DEFAULT 'normal',
  PRIMARY KEY (`id`),
  KEY `svnaccount` (`svnaccount`),
  KEY `windowsID` (`windowsID`),
  KEY `account` (`account`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;


#
# Structure for table "kt_class_item" 2017-10-31
#

CREATE TABLE IF NOT EXISTS `kt_class_item` (
  `id` int(1) unsigned NOT NULL AUTO_INCREMENT,
  `code` char(30) NOT NULL DEFAULT '',
  `title` char(30) NOT NULL DEFAULT '',
  `titleCN` varchar(30) NOT NULL DEFAULT '',
  `type` enum('book','chapter','article') NOT NULL DEFAULT 'chapter',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0',
  `parent` int(11) unsigned NOT NULL DEFAULT '0',
  `path` char(255) NOT NULL DEFAULT '',
  `grade` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `order` smallint(5) unsigned NOT NULL DEFAULT '0',
  `author` varchar(60) NOT NULL,
  `editor` varchar(60) NOT NULL,
  `addedDate` datetime NOT NULL,
  `editedDate` datetime NOT NULL,
  `deleted` enum('0','1') NOT NULL DEFAULT '0',
  `tempSouceID` int(1) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `parentIID_Unique` (`parent`,`code`),
  KEY `order` (`order`),
  KEY `parent` (`parent`),
  KEY `path` (`path`),
  KEY `type` (`type`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- ----------------------------
-- Table structure for kt_errcode
-- ----------------------------
CREATE TABLE IF NOT EXISTS `kt_errcode` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `project` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `code` char(30) NOT NULL DEFAULT '' COMMENT 'code name',
  `name` varchar(100) NOT NULL DEFAULT '',
  `nameEn` char(100) NOT NULL DEFAULT '',
  `status` int(11) NOT NULL DEFAULT '100' COMMENT 'status',
  `description` varchar(255) NOT NULL DEFAULT '',
  `openedBy` varchar(30) NOT NULL DEFAULT '',
  `openedDate` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `code` (`code`),
  KEY `name` (`name`) USING BTREE,
  KEY `nameEn` (`nameEn`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;
