<?php
/**
 * The browse mychart list file of ktchart module
 *
 * @copyright   Shanghai Kuntai Software Technology Co., Ltd. 2022
 * @author      kuntai
 * @date         2015-10-4
 * @package     ktchart
 */
?>
<?php include '../../common/view/header.html.php'; ?>
<?php include '../../common/view/datepicker.html.php'; ?>
<?php include './indexheader.html.php'; ?>

<div id="mainContent" class="main-row fade">
	<div class="side-col" id="sidebar">
		<div class="sidebar-toggle"><i class="icon icon-angle-left"></i></div>
		<div class="cell">
			<div class='panel-heading nobr'><?php echo html::icon($lang->icons['company']); ?> <strong>
					<?php common::printLink('ktchart', $methodName, "", $lang->ktchart->{$methodName}); ?></strong>
			</div>
			<div class='panel-body'>
				<ul class="tree treeview">
					<li>Item 1</li>
					<li>Item 2</li>
				</ul>
			</div>
		</div>
	</div>
	<div class='main'>
		<form method='post' class="main-table table-user" target="hiddenwin" data-ride='table'>
			<table class='table table-condensed table-hover table-striped tablesorter' id='itemlist'>
				<thead>
				<tr class='colhead'>
					<?php $vars = "&period=$period&orderBy=%s&recTotal={$pager->recTotal}&recPerPage={$pager->recPerPage}"; ?>
					<th class='w-id nobr'><?php common::printorderlink('id', $orderBy, $vars, $lang->idAB); ?></th>
					<th class='w-auto nobr'><?php common::printOrderLink('start', $orderBy, $vars, $lang->ktchart->start); ?></th>
					<th class='w-80px nobr'><?php common::printOrderLink('total', $orderBy, $vars, $lang->ktchart->total); ?></th>
					<th class='w-80px nobr'><?php common::printOrderLink('monitor', $orderBy, $vars, $lang->ktchart->monitor); ?></th>
					<th class='w-50px {sorter:false}  nobr'><?php echo $lang->actions; ?></th>
				</tr>
				</thead>
				<tbody>

				<?php foreach ($myItems as $myItem): ?>
					<tr class='text-center'>
						<td><?php echo $myItem->id; ?></td>
						<td><?php echo Date("Y-m-d H:i", $myItem->start); ?></td>
						<td><?php echo $myItem->total; ?></td>
						<td><?php echo $myItem->monitor; ?></td>
						<td class='text-center c-actions'>
							<?php
							common::printIcon('ktchart', 'view', "id=$myItem->id", '', '', 'search', '', 'iframe', 'yes');
							?>
						</td>
					</tr>
				<?php endforeach; ?>
				</tbody>
			</table>
			<div class='table-footer'>
				<?php
				$pager->show('right', 'pagerjs');
				?>
			</div>
		</form>
	</div>
</div>
<?php include '../../common/view/footer.html.php'; ?>
<script lanugage='javascript'>
	$('#<?php echo $methodName; ?>').addClass('active');

	var methodName = '<?php echo $methodName; ?>';
	var targetID = '<?php echo isset($id) ? $id : 0; ?>';
	<?php if (isset($lastMonth)): ?>
	var lastMonth = '<?php echo $lastMonth; ?>';
	var nextMonth = '<?php echo $nextMonth; ?>';
	<?php endif; ?>
</script>