
<?php

class ktclass extends control {

	public function __construct() {
		parent::__construct();
		$this->loadModel('ktbase');
	}
	
	/**
	 * Admin a book or a chapter.
	 * 
	 * @params int    $node
	 * @access public
	 * @return void
	 */
	public function admin($node = '') {
		if ($node) ($nodeItem	 = $this->ktclass->getNodeByID($node)) && $book		 = $nodeItem->book;
		if (!$node or ! $nodeItem) ($nodeItem	 = $book		 = $this->ktclass->getFirstBook()) && $node		 = $nodeItem->id;
		if (!$nodeItem) $this->locate(inlink('create'));

		$this->view->title		 = $this->lang->ktclass->common;
		$this->view->ktclass	 = $book;
		$this->view->books		 = $this->ktclass->getBookList();
		$this->view->nodeItem	 = $nodeItem;
		$this->view->catalog	 = $this->ktclass->getAdminCatalog($node, $this->ktclass->computeSN($book->id));

		$this->display();
	}

	public function book($node = '') {
		if ('' == $node) $nodeItem	 = $this->ktclass->getFirstBook();
		else $nodeItem	 = $this->ktclass->getNodeByID($node);
		if ($nodeItem) {
			$this->view->title		 = $nodeItem->title;
			$this->view->keywords	 = trim($nodeItem->keywords);
			$this->view->nodeItem	 = $nodeItem;
			$this->view->books		 = $this->ktclass->getBookList();
			//$this->view->catalog	 = $this->ktclass->getFrontCatalog($nodeItem->id, $this->ktclass->computeSN($nodeItem->id));
			$this->view->itemList	 = $this->ktclass->getChildren($nodeItem->id);
		}
		
		$thisLang				 = & $this->lang->ktclass;
		$this->view->title		 = $thisLang->common . $this->lang->colon . $thisLang->book;
		if ($nodeItem) $this->view->title .= $this->lang->colon . $nodeItem->title;
		$this->view->position[]	 = html::a($this->createLink($this->moduleName, 'index'), $thisLang->common);
		$this->view->position[]	 = $thisLang->book;

		$this->display();
	}

	/**
	 * Create a book.
	 *
	 * @access public 
	 * @return void
	 */
	public function create() {
		if ($_POST) {
			$bookID = $this->ktclass->createBook();
			if ($bookID) die(js::locate(inlink('book', "node=$bookID"), 'parent'));
		}

		$this->display();
	}
	
	/**
	 * Delete a node.
	 *
	 * @param int $node
	 * @retturn void
	 */
	public function delete($node) {
		$this->ktclass->delete($node);
		if (!dao::isError()) $this->send(array('result' => 'success'));
		$this->send(array('result' => 'fail', 'message' => dao::getError()));
	}
	
	/**
	 * Edit a book, a chapter or an article.
	 *
	 * @param int $node
	 * @access public
	 * @return void
	 */
	public function edit($node) {
		$nodeItem	 = $this->ktclass->getNodeByID($node, false);
		$book		 = $this->ktclass->getBookByNode($nodeItem);
		if ($_POST) {

			$this->ktclass->update($node);
			print_r($_POST);
			die(js::locate(inlink('index'), 'parent'));
		}

		/* Get option menu without this nodeItem's family nodes. */
		$optionMenu	 = $this->ktclass->getOptionMenu($book->id, $removeRoot	 = true);
		$families	 = $this->ktclass->getFamilies($nodeItem);
		foreach ($families as $member)
			unset($optionMenu[$member->id]);

		$this->view->title		 = $this->lang->edit . $this->lang->ktclass->typeList[$nodeItem->type];
		$this->view->nodeItem	 = $nodeItem;
		$this->view->optionMenu	 = $optionMenu;

		$this->display();
	}

	/**
	 * help.
	 *
	 * @access public 
	 * @return void
	 */
	public function help() {

		$this->display();
	}

	public function index($id = '', $orderBy = 'grade,`order`', $recTotal = 0, $recPerPage = 20, $pageID = 1) {
		if (!empty($_POST)) {
			if (isset($_POST['node'])) {
				$id		 = $_POST['node'];
				$type		 = $_POST['type'];
				$keywords	 = $_POST['keywords'];
			} else {
				$keywords	 = $_POST['book'];
				$type		 = 'book';
			}
		}

		//获得匹配的书籍列表
		$this->view->books	 = $this->ktclass->getBookList($keywords);
		//从列表中获取一本书
		if ('' === $id) $nodeItem	 = $this->ktclass->getFirstBook();
		else $nodeItem			 = $this->ktclass->getNodeByID($id);

		/* Set the pager. */
		$this->app->loadClass('pager', $static	 = true);
		$pager	 = pager::init($recTotal, $recPerPage, $pageID);

		$sort = $this->ktbase->appendOrder($orderBy);

		//如果关键子类型为type，获得关键字
		$thisLang				 = & $this->lang->ktclass;
		$this->view->title		 = $thisLang->common . $this->lang->colon . $thisLang->index;
		if ($nodeItem) $this->view->title .= $this->lang->colon . $nodeItem->title;
		$this->view->position[]	 = html::a($this->createLink($this->moduleName, 'index'), $thisLang->common);
		$this->view->position[]	 = $thisLang->index;
		$this->view->nodeItem	 = $nodeItem;
		$this->view->itemList	 = $this->ktclass->getNoteListByNode($nodeItem, $pager, $sort);

		$this->view->orderBy	 = $orderBy;
		$this->view->pager = $pager;
		$this->display();
	}


}
