<?php
/**
 * The 详细显示
 *
 * @copyright   Shanghai Kuntai Software Technology Co., Ltd. 2022
 * @author      kuntai
 * @package     ktdevice
 */
?>

<form method='post' class="main-table table-user" target="hiddenwin" data-ride='table'>
	<table class='table has-sort-head' id='DeviceList'>
		<thead>
		<tr class='colhead text-center'>
			<?php $vars = "param=$param&type=$type&orderBy=%s&recTotal={$pager->recTotal}&recPerPage={$pager->recPerPage}"; ?>
			<th class='w-id'><?php common::printorderlink('id', $orderBy, $vars, $lang->idAB); ?></th>
			<th class='w-130px'><?php common::printOrderLink('name', $orderBy, $vars, $lang->ktdevice->name); ?></th>
			<th class='w-130px'><?php common::printOrderLink('tcpip', $orderBy, $vars, $lang->ktdevice->tcpip); ?></th>
			<th class='w-50px'><?php echo $lang->ktdevice->yearlimit; ?></th>
			<th class='w-80px'><?php common::printOrderLink('label', $orderBy, $vars, $lang->ktdevice->label); ?></th>
			<th class='w-80px'><?php common::printOrderLink('user', $orderBy, $vars, $lang->ktdevice->user); ?></th>
			<th class='w-80px'><?php common::printOrderLink('charge', $orderBy, $vars, $lang->ktdevice->charge); ?></th>
			<th class='w-100px'><?php common::printOrderLink('dept', $orderBy, $vars, $lang->ktdevice->dept); ?></th>
			<th class='w-user'><?php common::printOrderLink('type', $orderBy, $vars, $lang->ktdevice->type); ?></th>
			<th class='w-80px'><?php common::printOrderLink('status', $orderBy, $vars, $lang->ktdevice->status); ?></th>
			<th class='w-250px'><?php common::printOrderLink('description', $orderBy, $vars, $lang->ktdevice->desc); ?></th>
			<th class='w-100px'><?php common::printOrderLink('repairend', $orderBy, $vars, $lang->ktdevice->repairend); ?></th>
			<th class='w-100px'><?php common::printOrderLink('join', $orderBy, $vars, $lang->ktdevice->join); ?></th>
			<th class='w-100px'><?php common::printOrderLink('dieDate', $orderBy, $vars, $lang->ktdevice->dieDate); ?></th>
			<th class='w-80px action'><?php echo $lang->actions; ?></th>
		</tr>
		</thead>
		<tbody>

		<?php
		$canBatchEdit      = false; //common::hasPriv('user', 'batchEdit');
		$canManageContacts = false; //common::hasPriv('user', 'manageContacts');
		$candevdelete      = common::hasPriv('ktdevice', 'devdelete');
		$canUserEdit       = common::hasPriv('ktdevice', 'devedit');
		?>
		<?php
		foreach ($devices as $device):
			$byend = time() - strtotime($device->repairend);
			if ($byend >= 0 && $device->repairend != "0000-00-00") $endstyle = 'background:red;';
			else $endstyle = '';
			$yearlimit         = time() - strtotime($device->join);
			$device->yearlimit = ceil($yearlimit / 60 / 60 / 24 / 365) - 1;
			if ($device->join == "0000-00-00") {
				$device->yearlimit = '';
				$linestyle         = "background:#D5D5D5;";
				$datestyle         = "";
			} elseif (time() - strtotime($device->join.'+5 years') >= 0) {
				$linestyle = "background:yellow;";
				$datestyle = "";
			} else {
				$linestyle = "";
				$datestyle = "color: green;";
			}
			?>
			<tr class='text-center'>
				<td>
					<?php
					if ($canBatchEdit or $canManageContacts) echo "<input type='checkbox' name='devices[]' value='$device->name'> ";
					printf('%03d', $device->id);
					?>
				</td>
				<td><?php if (!common::printLink('ktdevice', 'devview', "id=$device->id", $device->name)) echo $device->name; ?></td>
				<td><?php echo $device->tcpip; ?></td>
				<td style="<?php echo $linestyle.' '.$datestyle; ?>"><?php echo $device->yearlimit; ?></td>
				<td><?php echo $device->label; ?></td>
				<td><?php echo (isset($users[$device->user])) ? $users[$device->user] : $device->user; ?></td>
				<td><?php echo (isset($users[$device->charge])) ? $users[$device->charge] : $device->charge; ?></td>
				<td><?php echo $device->deptName; ?></td>
				<td><?php echo $lang->ktdevice->DevTypeList[$device->type]; ?></td>
				<td <?php if ('discard' == $device->status) echo 'style="background:yellow; "'; ?>><?php echo $lang->ktdevice->StatusList[$device->status]; ?></td>
				<td><?php echo $device->description; ?></td>
				<td style=<?php echo $endstyle ?>><?php echo ($device->repairend == "0000-00-00") ? "" : $device->repairend; ?></td>
				<td><?php echo ($device->join == "0000-00-00") ? "" : $device->join; ?></td>
				<td><?php echo ($device->dieDate == "0000-00-00") ? "" : $device->dieDate; ?></td>
				<td class='text-left c-actions'>
					<?php
					if ($canUserEdit) {
						common::printIcon('ktdevice', 'devedit', "userID=$device->id", '', 'list', 'pencil', '', 'iframe', true);
					}
					if ($candevdelete) {
						common::printIcon('ktdevice', 'devdelete', "userID=$device->id", '', 'list', 'trash', 'hiddenwin', '');
					}
					?>
				</td>
			</tr>
		<?php endforeach; ?>
		</tbody>
		<tfoot>
	</table>
	<div class='table-footer text-left'>
		<?php if ($canBatchEdit or $canManageContacts) { ?>
			<div class="checkbox-primary check-all"><label><?php echo $lang->selectAll ?></label></div>
			<div class="table-actions btn-toolbar"><?php echo html::submitButton($lang->edit, 'onclick=batchEdit()', 'btn-default');
				echo html::submitButton($lang->ktdevice->contacts->manage, 'onclick=manageContacts()');
				?></div>
		<?php }

		$pager->show('right', 'pagerjs');
		?>
	</div>
</form>