<?php
/**
 * The view file of user file of ktdevice module
 *
 * @copyright   Shanghai Kuntai Software Technology Co., Ltd. 2022
 * @author      kuntai
 * @package     ktdevice
 */
?>
<?php include '../../common/view/header.html.php'; ?>
<?php include '../../common/view/kindeditor.html.php'; ?>
<div id="mainMenu" class="clearfix">
	<div class="btn-toolbar pull-left">
		<?php $browseLink = inlink('devlist'); ?>
		<?php echo html::a($browseLink, '<i class="icon icon-back icon-sm"></i> '.$lang->goback, '', "class='btn btn-secondary'"); ?>
		<div class="divider"></div>
		<div class="page-title">
			<span class='label label-id'><?php echo $device->id; ?></span>
			<span class='prefix'><strong><?php echo $title." > "; ?></strong></span>
			<span class="text" title='<?php echo $device->name; ?>' '>
			<?php if ($device->deleted): ?>
				<span class='label label-danger'><?php echo $lang->ktdevice->deleted; ?></span>
			<?php endif; ?>
			<?php echo $device->name; ?>
			</span>
		</div>
	</div>
	<div class="btn-toolbar pull-right">
		<?php
		echo html::a(helper::createLink('ktdevice', 'devcreate', '', '', true), "<i class='icon-plus'></i> {$lang->ktdevice->devcreate}", '', "class='btn btn-primary iframe'");
		?>
	</div>
</div>
<div id="mainContent" class="main-row">
	<div class="main-col col-8">
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->legendBasic; ?></div>
			<table class='table table-data table-condensed table-borderless'>
				<tr>
					<th class='w-80px'><?php echo $lang->ktdevice->id; ?></th>
					<td class='w-auto'><?php echo $device->id; ?></td>
					<th class='w-80px'><?php echo $lang->ktdevice->name; ?></th>
					<td class='w-auto'><?php echo $device->name; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->label; ?></th>
					<td><?php echo $device->label; ?></td>
					<th><?php echo $lang->ktdevice->type; ?></th>
					<td><?php echo $lang->ktdevice->DevTypeList[$device->type]; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->status; ?></th>
					<td><?php echo $lang->ktdevice->StatusList[$device->status]; ?></td>
					<th><?php echo $lang->ktdevice->version; ?></th>
					<td><?php echo $device->version; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->assetNumber; ?></th>
					<td><?php echo $device->assetNumber; ?></td>
				</tr>
			</table>
		</div>
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->computerInfor; ?></div>
			<table class='table table-data table-condensed table-borderless'>
				<tr>
					<th class='w-80px'><?php echo $lang->ktdevice->tcpip; ?></th>
					<td><?php echo $device->tcpip; ?></td>
					<th><?php echo $lang->ktdevice->cpuID; ?></th>
					<td><?php echo $device->cpuID; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->deviceSN; ?></th>
					<td><?php echo $device->deviceSN; ?></td>
					<th><?php echo $lang->ktdevice->monitorSN; ?></th>
					<td><?php echo $device->monitorSN; ?></td>

				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->mac; ?></th>
					<td><?php echo $device->mac; ?></td>
					<th><?php echo $lang->ktdevice->purpose; ?></th>
					<td><?php echo $device->purpose; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->vidioCard; ?></th>
					<td><?php echo $device->vidioCard; ?></td>
					<th><?php echo $lang->ktdevice->discCapacity; ?></th>
					<td><?php echo $device->discCapacity; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->memoryCapacity; ?></th>
					<td><?php echo $device->memoryCapacity; ?></td>
				</tr>
			</table>
		</div>
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->desc; ?></div>
			<div class='article-content'><?php echo nl2br($device->description); ?></div>
		</div>
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->group; ?></div>
			<div class='article-content'><?php
				$groulist = "";
				foreach ($deviceGroups as $group):
					if ($group->id) {
						echo " <span class='prefix'><strong>";
						common::printLink('ktdevice', 'groupview', "groupid=$group->id", $group->name);
						echo "</strong></span> ";
					}
				endforeach;
				?></div>
		</div>
		<div class='main-actions'>
			<div class="btn-toolbar">
				<?php common::printBack($browseLink); ?>
				<div class='divider'></div>
				<?php
				common::printIcon('ktdevice', 'devedit', "userID=$device->id", $device, 'button', 'pencil', '', 'iframe', true);
				common::printIcon('ktdevice', 'devdelete', "userID=$device->id", $device, 'button', 'close', '', 'iframe', true, "data-width='550'");

				echo $this->buildOperateMenu($device, 'view');
				?>

			</div>
		</div>
	</div>
	<div class="side-col col-4">
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->UserVisitInfor; ?></div>
			<table class='table table-data table-condensed table-borderless'>
				<tr>
					<th><?php echo $lang->ktdevice->join; ?></th>
					<td><?php echo $device->join; ?> </td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->dieDate; ?></th>
					<td><?php echo $device->dieDate; ?> </td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->dept; ?></th>
					<td><?php echo $deptName; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->user; ?></th>
					<td><?php echo $device->userName; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->charge; ?></th>
					<td><?php echo $device->chargeName; ?></td>
				</tr>
			</table>
		</div>
	</div>
</div>
</div>
<?php include '../../common/view/syntaxhighlighter.html.php'; ?>
<?php include '../../common/view/footer.html.php'; ?>
