<?php
/**
 * The view file of group of ktdevice module
 *
 * @copyright   Shanghai Kuntai Software Technology Co., Ltd. 2022
 * @author      kuntai
 * @package     ktdevice
 */
?>
<?php include '../../common/view/header.html.php'; ?>
<?php include '../../common/view/kindeditor.html.php'; ?>
<div id="mainMenu" class="clearfix">
	<div class="btn-toolbar pull-left">
		<?php $browseLink = inlink('grouplist'); ?>
		<?php echo html::a($browseLink, '<i class="icon icon-back icon-sm"></i> '.$lang->goback, '', "class='btn btn-secondary'"); ?>
		<div class="divider"></div>
		<div class="page-title">
			<span class='label label-id'><?php echo $group->id; ?></span>
			<span class='prefix'><strong><?php echo $title." > "; ?></strong></span>
			<span class="text" title='<?php echo $group->name; ?>' '>
			<?php if ($group->deleted): ?>
				<span class='label label-danger'><?php echo $lang->ktdevice->deleted; ?></span>
			<?php endif; ?>
			<?php echo $group->name; ?>
			</span>
		</div>
	</div>
	<div class="btn-toolbar pull-right">
		<?php
		echo html::a(helper::createLink('ktdevice', 'groupcreate', '', '', true), "<i class='icon-plus'></i> {$lang->ktdevice->groupcreate}", '', "class='btn btn-primary iframe'");
		?>
	</div>
</div>
<div id="mainContent" class="main-row">
	<div class="main-col col-8">
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->desc; ?></div>
			<div class='article-content'><?php echo $group->desc; ?></div>
		</div>
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->dev; ?></div>
			<div class='article-content'>
				<table><?php
					$index     = 0;
					$avaliable = false;//标记是否存在有效数据
					foreach ($devices as $device):
						if ($device->id) {
							$avaliable = true;
							if ($index % 8 == 0) {
								if ($index > 0) echo "</tr>";
								echo "<tr>";
							}
							echo "<td><span class='prefix'><strong>";
							common::printLink('ktdevice', 'devview', "userid=$device->id", "{$device->name}({$lang->ktdevice->DevTypeList[$device->type]})");
							echo "</strong></span></td>";
							$index++;
						}
					endforeach;
					if ($avaliable) echo "</tr>";
					?>
				</table>
			</div>
		</div>
		<div class='main-actions'>
			<div class="btn-toolbar">
				<?php common::printBack($browseLink); ?>

				<div class='divider'></div>
				<?php
				common::printIcon('ktdevice', 'groupedit', "userID=$group->id", $group, 'button', 'pencil', '', 'iframe', true);
				common::printIcon('ktdevice', 'groupdelete', "userID=$group->id", $group, 'button', 'trash', '', 'iframe', true, "data-width='550'");

				echo $this->buildOperateMenu($group, 'view');
				?>

			</div>
		</div>
	</div>
	<div class="side-col col-4">
		<div class="cell">
			<div class="detail-title"><?php echo $lang->ktdevice->legendBasic; ?></div>
			<table class='table table-data table-condensed table-borderless'>
				<tr>
					<th class='w-80px'><?php echo $lang->ktdevice->id; ?></th>
					<td><?php echo $group->id; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->name; ?></th>
					<td><?php echo $group->name; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->type; ?></th>
					<td><?php echo $lang->ktdevice->GroupTypeList[$group->type]; ?></td>
				</tr>
				<tr>
					<th><?php echo $lang->ktdevice->createdate; ?></th>
					<td><?php echo $group->createdate; ?></td>
				</tr>
			</table>
		</div>
	</div>
</div>
<?php include '../../common/view/syntaxhighlighter.html.php'; ?>
<?php include '../../common/view/footer.html.php'; ?>
