<?php
/**
 * The browse user view file of ktsvnmanager module
 *
 * @copyright   Shanghai Kuntai Software Technology Co., Ltd. 2022
 * @author      kuntai
 * @package     ktsvnmanager
 */
?>
<?php
include '../../common/view/header.html.php';
$repedit	 = common::hasPriv('ktsvnmanager', 'repedit');
//$reparse=common::hasPriv('ktsvnmanager','reparse');
//$authzparse=common::hasPriv('ktsvnmanager','authzparse');
$repdelete	 = common::hasPriv('ktsvnmanager', 'repdelete');
$isAdmin	 = ($this->ktsvnmanager->svnUser->type == 'admin');

function func_SearchItem($name, $title, $value, $List = "") {
	echo "<tr><th class='text-left nobr'>";
	if ($value) {
		echo "<a href=\"javascript:onRemoveSearchChoice('$name', '');\" class=\"\" title='Delete'>$title</a></th>";
	} else echo $title;
	echo "<td style='max-width:150px'>";
	if ($name == "charger") {
		echo html::select('charger', $List, $value, "class='form-control chosen'");
	} else echo html::input($name, $value, "class='form-control'");
	echo "</td></tr>";
}
?>
<div id='featurebar'>
	<ul class="nav">
		<?php
		foreach ($lang->ktsvnmanager->reptypes as $key => $label) {
			if ($key != 'my' && !$isAdmin) continue;
			echo "<li data-id=$key " . (($key === $type) ? "class='active'" : '') . '>' . html::a(inLink('authzlist', "type=$key"), $label, '', "") . '</li>';
		}
		?>
	</ul>
</div>

<div class='side'>
	<a class='side-handle' data-id='ktsvnmanagerTree'><i class='icon-caret-left'></i></a>
	<div class='side-body'>
		<div class='panel panel-sm'>
			<div class='panel-heading nobr'><?php echo html::icon($lang->icons['company']);?> <strong><?php echo $lang->ktsvnmanager->filter;?></strong></div>
			<form id='searchform' method="post" class='form-condensed'  style="height:370px;">
				<?php echo html::hidden('postType', 'searchform');?>
				<table class='table table-form'>
					<?php
					func_SearchItem("name", $lang->ktsvnmanager->rep, $FilterList->name);
					if ($type != 'my' && $isAdmin) func_SearchItem("charger", "用户", $FilterList->charger, $this->ktsvnmanager->svnUsers->PairsAll);
					?>
					<tr>
						<td class='text-center' colspan="2"><?php echo html::submitButton('Search');?></td>
					</tr>
				</table>
			</form>
		</div>
	</div>
</div>
<div class='main'>
	<table class='table table-condensed table-hover table-striped tablesorter' id='authzList'>
		<thead>
			<tr class='text-left'>
				<?php $vars		 = "type=$type&orderBy=%s&recTotal={$pager->recTotal}&recPerPage={$pager->recPerPage}";?>
				<th class='w-id'><?php common::printOrderLink('a.id', $orderBy, $vars, $lang->ktsvnmanager->id);?></th>
				<th class='w-auto'><?php common::printOrderLink('a.rep', $orderBy, $vars, $lang->ktsvnmanager->rep);?></th>
				<th class='w-auto'><?php common::printOrderLink('a.folder', $orderBy, $vars, $lang->ktsvnmanager->folder);?></th>
				<th class='w-auto'><?php common::printOrderLink('a.user', $orderBy, $vars, $lang->ktsvnmanager->account);?></th>
				<th class='w-auto'><?php common::printOrderLink('a.authz', $orderBy, $vars, $lang->ktsvnmanager->authz);?></th>
			</tr>
		</thead>
		<tbody>
			<?php
			$canedit	 = common::hasPriv('ktsvnmanager', 'repedit');
			$candelete	 = common::hasPriv('ktsvnmanager', 'repdelete');

			$users = &$this->ktsvnmanager->svnUsers->PairsAll;
			foreach ($authzList as $item):
				?>
				<tr class='text-left'>
					<td><?php echo $item->id;?></td>
					<td><?php
						common::printIcon('ktsvnmanager', 'authz', "repid=$item->rep", '', '', 'list', '', '', false);
						common::printIcon('ktsvnmanager', 'authz', "repid=$item->rep", '', '', 'search', '', 'iframe', true);
						echo "[$item->rep]$item->name";
						?></td>
					<td><?php echo $item->folder;?></td>
					<td ><?php echo ((isset($users[$item->user])) ? $users[$item->user] : $item->user);?></td>
					<td><?php echo $lang->ktsvnmanager->authzEnum[$item->authz];?></td>
				</tr>
				<?php
			endforeach;
			?>
		</tbody>
		<tfoot>
			<tr>
				<td colspan='12'>
					<?php echo $pager->show();?>
				</td>
			</tr>
		</tfoot>
	</table>
</div>
<?php include '../../common/view/footer.html.php';?>
