<?php

/**
 * The browse user view file of ktsvnmanager module
 *
 * @copyright   Shanghai Kuntai Software Technology Co., Ltd. 2022
 * @author      kuntai
 * @package     ktsvnmanager
 */
?>
<?php
include '../../common/view/header.html.php';
$repedit   = common::hasPriv('ktsvnmanager', 'repedit');
$repdelete = common::hasPriv('ktsvnmanager', 'repdelete');
$repcreate = common::hasPriv('ktsvnmanager', 'repcreate');
$repsync   = common::hasPriv('ktsvnmanager', 'repsync');
$authz     = common::hasPriv('ktsvnmanager', 'authz');
$isAdmin   = false;
if (isset($this->ktsvnmanager->svnUser ) && isset($this->ktsvnmanager->svnUser->type )){
	$isAdmin   = ($this->ktsvnmanager->svnUser->type == 'admin');
} 

if ($reptype != 'my' && !$isAdmin) $reptype = "my";

function func_SearchItem($name, $title, $value, $List = "")
{
	echo "<tr><th class='text-left nobr ' style='width:50px'>";
	if ($value) {
		echo "<a href=\"javascript:onRemoveSearchChoice('$name', '');\" class=\"\" title='Delete'>$title</a></th>";
	} else echo $title;
	echo "<td style='max-width:150px'>";
	if ($name == "charger") {
		echo html::select('charger', $List, $value, "class='form-control chosen'");
	} else echo html::input($name, $value, "class='form-control'");
	echo "</td></tr>";
}

?>

<div id="mainContent" class="main-row fade">
	<div class="side-col" id="sidebar">
		<div class="sidebar-toggle"><i class="icon icon-angle-left"></i></div>

		<div class='cell'>
			<div class="cell">
				<div class="btn-toolbar">
					<?php
					foreach ($lang->ktsvnmanager->reptypes as $type => $label) {
						if ($type != 'my' && !$isAdmin) continue;
						echo html::a(inLink('index', "reptype=$type"), $label, '', "");
					}
					?>
				</div>
			</div>
			<div class='panel panel-sm'>
				<div class='panel-heading nobr'><?php echo html::icon($lang->icons['company']); ?>
					<strong><?php echo $lang->ktsvnmanager->filter; ?></strong>
				</div>
				<form id='searchform' method="post" class='form-condensed' style="height:370px;">
					<?php echo html::hidden('postType', 'searchform'); ?>
					<table class='table table-form'>
						<?php
						func_SearchItem("name", $lang->ktsvnmanager->folder, $FilterList->name);
						func_SearchItem("title", $lang->ktsvnmanager->title, $FilterList->title);
						func_SearchItem("project", $lang->ktsvnmanager->project, $FilterList->project);
						if ($reptype != 'my' && $isAdmin) func_SearchItem("charger", "负责", $FilterList->charger, $chargers);
						?>
						<tr>
							<td class='text-center' colspan="2"><?php echo html::submitButton('Search'); ?></td>
						</tr>
					</table>
					<div class="btn-toolbar">
						<?php
						echo "<br>";
						if ($repcreate) echo html::a(helper::createLink('ktsvnmanager', 'repcreate', '', '', true), "<i class='icon-plus'></i> " . $lang->ktsvnmanager->repcreate, '', "data-toggle='modal' data-type='iframe' class='btn'");
						echo "<br>";
						if ($repsync) echo html::a(helper::createLink('ktsvnmanager', 'repsync', '', '', false), "<i class='icon-refresh'></i> " . $lang->ktsvnmanager->repsync, '', "class='btn'");
						?>
					</div>
				</form>

			</div>

		</div>
	</div>
	<div class='main-col main-table'>
		<table class='table has-sort-head'>
			<thead>
				<tr class='colhead text-center'>
					<?php $vars = "reptype=$reptype&orderBy=%s&recTotal={$pager->recTotal}&recPerPage={$pager->recPerPage}"; ?>
					<th class='w-id'><?php common::printorderlink('id', $orderBy, $vars, $lang->idAB); ?></th>
					<th class='w-auto text-left'><?php common::printOrderLink('name', $orderBy, $vars, $lang->ktsvnmanager->name); ?></th>
					<th class='w-auto text-left'><?php common::printOrderLink('title', $orderBy, $vars, $lang->ktsvnmanager->title); ?></th>
					<th class='w-auto text-left'><?php common::printOrderLink('project', $orderBy, $vars, $lang->ktsvnmanager->project); ?></th>
					<th class='w-auto text-left'><?php common::printOrderLink('dept', $orderBy, $vars, $lang->ktsvnmanager->dept); ?></th>
					<th class='w-80px text-left'><?php common::printOrderLink('charger', $orderBy, $vars, $lang->ktsvnmanager->charger); ?></th>
					<th class='w-100px text-left'><?php common::printOrderLink('description', $orderBy, $vars, $lang->ktsvnmanager->description); ?></th>
					<th class='w-100px text-left'><?php common::printOrderLink('class', $orderBy, $vars, $lang->ktsvnmanager->class); ?></th>
					<th class='w-140px'><?php echo $lang->actions; ?></th>
				</tr>
			</thead>
			<tbody>

				<?php
				$canedit   = common::hasPriv('ktsvnmanager', 'repedit');
				$candelete = common::hasPriv('ktsvnmanager', 'repdelete');
				?>
				<?php
				$this->ktsvnmanager->getAccountPairs();
				foreach ($replist as $repinfo) :
					$RealName = $repinfo->realname;
					if (!$RealName && array_key_exists($repinfo->charger, $this->ktsvnmanager->svnUsers->PairsAll)) {
						$RealName = $this->ktsvnmanager->svnUsers->PairsAll[$repinfo->charger];
					}
				?>
					<tr class='text-center'>
						<td <?php echo ($repinfo->disable) ? "style='background:red;'" : ''; ?>><?php echo $repinfo->id; ?></td>
						<td class="text-left"><?php echo $repinfo->name; ?></td>
						<td class="text-left"><?php echo $repinfo->title; ?></td>
						<td class="text-left"><?php if ($repinfo->project) echo "[$repinfo->project]$repinfo->ProjectName"; ?></td>
						<td class="text-left"><?php echo $repinfo->DeptName; ?></td>
						<td class="text-left"><?php echo $RealName; ?></td>
						<td class="text-left"><?php echo $repinfo->description; ?></td>
						<td class="text-left"><?php echo $repinfo->class; ?></td>
						<!--<td><?php // echo $repinfo->disable;
								?></td>-->
						<?php if ($repedit || $repdelete) : ?>
							<td class='text-left  c-actions'>
								<?php
								echo (($authz) ? common::printIcon('ktsvnmanager', 'authz', "repid=$repinfo->id", '', '', 'search', '', 'iframe', true) : '');
								echo (($authz) ? common::printIcon('ktsvnmanager', 'authz', "repid=$repinfo->id", '', '', 'lock', '', '', false) : '');

								echo (($repedit) ? common::printIcon('ktsvnmanager', 'repedit', "repid=$repinfo->id", '', '', 'pencil', '', 'iframe', true) : '');
								echo (($repdelete) ? common::printIcon('ktsvnmanager', 'repdelete', "repid=$repinfo->id", '', '', 'trash', '', 'iframe', true, "data-width='550'") : '');
								echo "<a href='javascript:void(0);' οnclick='copy()' class='btn' title='{$lang->ktsvnmanager->copysvn}'><i class='icon icon-copy'></i></a>";
								//<button type='button' class='btn-icon' onclick='copy();' id='url' value='" . $this->config->ktsvnmanager->ServerLinkPrifix . $repinfo->name . "' title='{$lang->ktsvnmanager->copysvn}'><i class='icon-copy'></i></button>";
								?>
							</td>
						<?php endif; ?>
					</tr>
				<?php endforeach; ?>
			</tbody>
		</table>
		<div class='table-footer'>
			<?php $pager->show('right', 'pagerjs'); ?>
		</div>
	</div>
</div>
<?php include '../../common/view/footer.html.php'; ?>
<script type="text/javascript">
	function copy() {
		var cpTxt = $('#url').val();
		var clipobj = window.clipboardData;
		if (clipobj) {
			clipobj.clearData();
			clipobj.setData('Text', cpTxt);
		} else if (navigator.userAgent.indexOf("Opera") != -1) {
			window.location = cpTxt;
		} else if (window.netscape) {
			try {
				netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
			} catch (e) {
				alert("被浏览器拒绝！\n请在浏览器地址栏输入'about:config'并回车\n然后将'signed.applets.codebase_principal_support'设置为'true'");
			}
			var clip = Components.classes['@mozilla.org/widget/clipboard;l'].createInstance(Components.interfaces.nsIClipboard);
			if (!clip) return;
			var trans = Components.classes['@mozilla.org/widget/transferable;l'].createInstance(Components.interfaces.nsITransferable);
			if (!trans) return;
			trans.addDataFlavor("text/unicode");
			var str = new Object();
			var len = new Object();
			var str = Components.classes["@mozilla.org/supports-string;l"].createInstance(Components.interfaces.nsISupportsString);
			var copytext = cpTxt;
			str.data = copytext;
			trans.setTransferData("text/unicode", str, copytext.length * 2);
			var clipid = Components.interfaces.nsIClipboard;
			if (!clip) return false;
			clip.setData(trans, null, clipid.kGlobalClipboard);
		}
	}
</script>